summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorDenis 'GNUtoo' Carikli <GNUtoo@cyberdimension.org>2018-12-22 14:16:40 +0100
committerDenis 'GNUtoo' Carikli <GNUtoo@cyberdimension.org>2018-12-22 17:49:31 +0100
commit8a09f6f6da7126a778b2ec93310d75e39b664c73 (patch)
treeb5c974c96fbc5ce9f980e69ba5469f91ce3a4bc4
parent57f85dc777a03b7789beae72f67fc3ec698a13d1 (diff)
libre: Add x86_64-pc-linux-gnu gcc and binutils
This will enable users to build code for x86_64 on i686 and armv7h. The PKGBUILDS are based on the arm-linux-gnueabi- binutils and gcc. Signed-off-by: Denis 'GNUtoo' Carikli <GNUtoo@cyberdimension.org>
-rw-r--r--libre/x86_64-pc-linux-gnu-binutils/PKGBUILD64
-rw-r--r--libre/x86_64-pc-linux-gnu-gcc/PKGBUILD98
2 files changed, 162 insertions, 0 deletions
diff --git a/libre/x86_64-pc-linux-gnu-binutils/PKGBUILD b/libre/x86_64-pc-linux-gnu-binutils/PKGBUILD
new file mode 100644
index 000000000..cf79e6928
--- /dev/null
+++ b/libre/x86_64-pc-linux-gnu-binutils/PKGBUILD
@@ -0,0 +1,64 @@
+# Contributor: Denis 'GNUtoo' Carikli <GNUtoo@no-log.org>
+
+_target=x86_64-pc-linux-gnu
+pkgname=$_target-binutils
+pkgver=2.31.1
+pkgrel=1
+pkgdesc='A set of programs to assemble and manipulate binary and object files for the x86_64 target'
+arch=('x86_64' 'i686' 'armv7h')
+url='http://www.gnu.org/software/binutils/'
+license=(GPL)
+depends=(zlib)
+source=(https://ftp.gnu.org/gnu/binutils/binutils-$pkgver.tar.bz2{,.sig})
+sha512sums=('b42954e6f49a0adcd2676bdd77dfb59bfc25cec8184b007521d1e2b1d5d0593b58639e3d9448d5a40fe024c3cea386a37743627d6bb16d502f52a4a32b9573bd'
+ 'SKIP')
+validpgpkeys=('EAF1C276A747E9ED86210CBAC3126D3B4AE55E93' # Tristan Gingold <gingold@adacore.com>
+ '3A24BC1E8FB409FA9F14371813FCEF89DD9E3C4F') # Nick Clifton (Chief Binutils Maintainer) <nickc@redhat.com>
+
+prepare() {
+ cd binutils-$pkgver
+ sed -i "/ac_cpp=/s/\$CPPFLAGS/\$CPPFLAGS -O2/" libiberty/configure
+}
+
+build() {
+ cd binutils-$pkgver
+
+ if [ "${CARCH}" != "i686" ]; then
+ # enabling gold linker at i686 makes the install fail
+ enable_gold='--enable-gold'
+ fi
+
+ ./configure --target=$_target \
+ --with-sysroot=/usr/$_target \
+ --prefix=/usr \
+ --with-gnu-as \
+ --with-gnu-ld \
+ --disable-nls \
+ --enable-ld=default \
+ $enable_gold \
+ --enable-multilib \
+ --enable-plugins \
+ --enable-deterministic-archives
+
+ make
+}
+
+check() {
+ cd binutils-$pkgver
+
+ # unset LDFLAGS as testsuite makes assumptions about which ones are active
+ # do not abort on errors - manually check log files
+ make LDFLAGS="" -k check || true
+}
+
+package() {
+ cd binutils-$pkgver
+
+ make DESTDIR="$pkgdir" install
+
+ # Remove file conflicting with host binutils and manpages for MS Windows tools
+ rm "$pkgdir"/usr/share/man/man1/$_target-{dlltool,windres,windmc}*
+
+ # Remove info documents that conflict with host version
+ rm -r "$pkgdir"/usr/share/info
+}
diff --git a/libre/x86_64-pc-linux-gnu-gcc/PKGBUILD b/libre/x86_64-pc-linux-gnu-gcc/PKGBUILD
new file mode 100644
index 000000000..25e3257cd
--- /dev/null
+++ b/libre/x86_64-pc-linux-gnu-gcc/PKGBUILD
@@ -0,0 +1,98 @@
+# Contributor: Denis 'GNUtoo' Carikli <GNUtoo@no-log.org>
+
+_target=x86_64-pc-linux-gnu
+pkgname=$_target-gcc
+_pkgver=8.2.0
+#_snapshot=8-20180824
+pkgver=$_pkgver${_snapshot/*-/+}
+_islver=0.19
+pkgrel=1
+pkgdesc="The GNU Compiler Collection - cross compiler for x86_64 target"
+arch=('x86_64' 'i686' 'armv7h')
+url='http://gcc.gnu.org/'
+license=(GPL LGPL FDL)
+depends=($_target-binutils libmpc zlib)
+makedepends=(gmp mpfr)
+options=(!emptydirs !strip)
+source=(https://gcc.gnu.org/pub/gcc/releases/gcc-$_pkgver/gcc-$_pkgver.tar.xz
+ #https://gcc.gnu.org/pub/gcc/snapshots/$_snapshot/gcc-$_snapshot.tar.xz
+ http://isl.gforge.inria.fr/isl-$_islver.tar.bz2)
+sha512sums=('64898a165f67e136d802a92e7633bf1b06c85266027e52127ea025bf5fc2291b5e858288aac0bdba246e6cdf7c6ec88bc8e0e7f3f6f1985f4297710cafde56ed'
+ '08f4db964d9e02ec8aa9779378ed76e0ddf1d56f81f87664dbf787555ce496cdc87e836f8a51ae137f45e648c604870cce07ee45919eafb549e404afb8f27083')
+
+if [ -n "$_snapshot" ]; then
+ _basedir=gcc-$_snapshot
+else
+ _basedir=gcc-$_pkgver
+fi
+
+prepare() {
+ cd $_basedir
+
+ # link isl for in-tree builds
+ ln -sf ../isl-$_islver isl
+
+ echo $_pkgver > gcc/BASE-VER
+
+ # hack! - some configure tests for header files using "$CPP $CPPFLAGS"
+ sed -i "/ac_cpp=/s/\$CPPFLAGS/\$CPPFLAGS -O2/" "$srcdir"/$_basedir/{libiberty,gcc}/configure
+
+ mkdir $srcdir/build-gcc
+}
+
+build() {
+ cd build-gcc
+
+ # using -pipe causes spurious test-suite failures
+ # http://gcc.gnu.org/bugzilla/show_bug.cgi?id=48565
+ CFLAGS=${CFLAGS/-pipe/}
+ CXXFLAGS=${CXXFLAGS/-pipe/}
+
+ $srcdir/$_basedir/configure \
+ --target=$_target \
+ --prefix=/usr \
+ --libexecdir=/usr/lib \
+ --enable-languages=c,c++ \
+ --enable-multilib \
+ --enable-plugins \
+ --enable-shared \
+ --disable-decimal-float \
+ --disable-libffi \
+ --disable-libgomp \
+ --disable-libmudflap \
+ --disable-libquadmath \
+ --disable-libssp \
+ --disable-libstdcxx-pch \
+ --disable-nls \
+ --disable-threads \
+ --disable-tls \
+ --with-gnu-as \
+ --with-gnu-ld \
+ --with-system-zlib \
+ --with-gmp \
+ --with-mpfr \
+ --with-mpc \
+ --with-isl \
+ --with-libelf \
+ --enable-gnu-indirect-function \
+ --with-pkgversion='Parabola Repository' \
+ --with-bugurl='https://labs.parabola.nu/'
+
+ make $MAKEFLAGS all-gcc
+}
+
+package() {
+ cd build-gcc
+
+ make DESTDIR="$pkgdir" install-gcc
+
+ # strip target binaries
+ find "$pkgdir"/usr/lib/gcc/$_target/ -type f -and \( -name \*.a -or -name \*.o \) -exec $_target-objcopy -R .comment -R .note -R .debug_info -R .debug_aranges -R .debug_pubnames -R .debug_pubtypes -R .debug_abbrev -R .debug_line -R .debug_str -R .debug_ranges -R .debug_loc '{}' \;
+
+ # strip host binaries
+ find "$pkgdir"/usr/bin/ "$pkgdir"/usr/lib/gcc/$_target/ -type f -and \( -executable \) -exec strip '{}' \;
+
+ # Remove files that conflict with host gcc package
+ rm -r "$pkgdir"/usr/share/man/man7
+ rm -r "$pkgdir"/usr/share/info
+}